import React, { useState } from "react";

export const Pagination = ({
  totalPosts,
  postsPerPage,
  paginate,
  color,
  bgColor,
  boxHeight,
  boxWidth,
  justify,
  boxRadius,
  view,
}) => {
  const pageNumbers = [];
  for (let i = 1; i <= Math.ceil(totalPosts / postsPerPage); i++) {
    pageNumbers.push(i);
  }

  const spanStyles = {
    display: "flex",
    justifyContent: "center",
    alignItems: "center",
    color: color ? color : "white",
    backgroundColor: bgColor ? bgColor : "skyblue",
    width: boxWidth ? boxWidth : "40px",
    height: boxHeight ? boxHeight : "40px",
    cursor: "pointer",
    borderRadius: boxRadius ? boxRadius : "50%",
  };

  const mainStyles = {
    display: "flex",
    justifyContent: justify ? justify : "space-evenly",
  };

  const [number, setNumber] = useState(0);

  const items = view ? view : 5;

  const onNext = () => {
    setNumber(number + 1);
  };
  const onPrevious = () => {
    setNumber(number - 1);
  };

  const max = Math.ceil(pageNumbers.length / items);

  return (
    <div style={mainStyles}>
      {number > 0 ? (
        <div onClick={() => onPrevious()} style={spanStyles}>
          {"<<"}
        </div>
      ) : undefined}
      {pageNumbers.slice(number * view, number * view + view).map((number) => {
        return (
          <div key={number} onClick={() => paginate(number)} style={spanStyles}>
            {number}
          </div>
        );
      })}
      {number !== max - 1 ? (
        <div onClick={() => onNext()} style={spanStyles}>
          {">>"}
        </div>
      ) : undefined}
    </div>
  );
};
